/*
 *	JFont
 *	(SwingOSC classes for SuperCollider)
 *
 *	Replacement for the cocoa font class.
 *
 *	@author		SuperCollider Developers
 *	@author		Hanns Holger Rutz
 *	@version		0.44, 05-Dec-06
 */
JFont {
	classvar <>verbose = false;

	classvar <>default;
	
	// JJJ
	classvar defaultSansFace, defaultSerifFace, defaultMonoFace;
	
					 // JJJ
	var <>name, <>size, <>style;
		
	// JJJ
	*initClass {
		if( thisProcess.respondsTo( \platform ) and: {thisProcess.platform.name === \osx }, {
			default			= JFont( "LucidaGrande", 11 );
			defaultSansFace	= "LucidaGrande";
			defaultSerifFace	= "Times";
			defaultMonoFace	= "Monaco";
		}, {
			default			= JFont( "SansSerif", 12 );
			defaultSansFace	= "SansSerif";
			defaultSerifFace	= "Serif";
			defaultMonoFace	= "Monospaced";
		});
	}
		
	*new { arg name, size, style = 0;
		^super.newCopyArgs( name, size, style );
	}
	setDefault { default = this }
	
	*availableFonts {
		// returns an Array of font names.
		"JFont.availableFonts : not yet implemented".error;
		^[ "Dialog", "DialogInput", "Monospaced", "SansSerif", "Serif" ];
//		_Font_AvailableFonts
//		^this.primitiveFailed
	}
	*antiAliasing_ { arg flag = false;
		if( verbose, { "JFont.antiAliasing : has no effect".error; });
//		_Font_SetAntiAliasing;
//		^this.primitiveFailed
	}
	*smoothing_ { arg flag = false;
		if( verbose, { "JFont.smoothing : has no effect".error; });
//		_Font_SetSmoothing;
//		^this.primitiveFailed
	}
	// JJJ
	storeArgs { ^[ name, size, style ] }

	boldVariant {
		^this.class.new( name, size, style | 1 );
	}

	*defaultSansFace {
		^defaultSansFace;
	}
	
	*defaultSerifFace {
		^defaultSerifFace;
	}
	
	*defaultMonoFace {
		^defaultMonoFace;
	}
}