/*
 *	SwingDialog
 *	(SwingOSC classes for SuperCollider)
 *
 *	A replacement for CocoaDialog.
 *
 *	Not yet working:
 *	- multiple input file selection
 *
 *	Different behaviour
 *
 *	Added features
 *
 *	@author		SuperCollider Developers
 *	@author		Hanns Holger Rutz
 *	@version		0.42, 03-Oct-06
 */
SwingDialog {
	classvar result, ok, cancel;

	*initClass {
		UI.registerForReset({ this.clear });
	}
	
	*getPaths { arg okFunc, cancelFunc, maxSize=20;
		if(result.notNil,{
			"A SwingDialog is already in progress.  do: [SwingDialog.clear]".warn;
			^nil
		});
		
		result = Array.new(maxSize);
		ok = okFunc;
		cancel = cancelFunc;
		this.prGetPathsDialog(result);
	}
	
	*prGetPathsDialog { arg argResult;
//		_Swing_GetPathsDialog
//		^this.primitiveFailed
		this.prShowDialog( "Open", 0 );
	}

	// JJJ begin
	*prShowDialog { arg title, mode;
		var server, swing, dlg, frame, file, dir, isOk, visible, wResp, wJResp, err;

		server	= SwingOSC.default;
		frame	= JavaObject( 'java.awt.Frame', server );
		dlg 		= JavaObject( 'java.awt.FileDialog', server, frame, title, mode );
//		dlg.setModal( false );
		wResp	= OSCresponderNode( server.addr, '/window', { arg time, resp, msg;
			if( (msg[ 1 ] === dlg.id) and: { msg[ 2 ] === \closed }, {
				wResp.remove;
				wJResp.remove;
				wJResp.destroy;
				fork {
					swing 	= JavaObject.getClass( 'de.sciss.swingosc.SwingOSC', server );
					file		= JavaObject.newFrom( dlg, \getFile );
					isOk		= swing.notNull_( file );
					swing.destroy;
//					("isOk == "++isOk).inform;
					try {
						if( isOk.notNil and: { isOk != 0 }, {
							file.destroy;
							file	= dlg.getFile_;
							dir	= dlg.getDirectory_;
							if( mode === 0, {
								result.add( dir.asString ++ file.asString );
							}, {
								result = dir.asString ++ file.asString;
							});
							this.ok;
						}, {
							this.cancel;
						});
					}
					{ arg error;
						err = error;
					};
					dlg.destroy;
					frame.dispose;
					frame.destroy;
					this.clear;
					if( err.notNil, {err.throw; });
				};
			});
		});
		wResp.add;
		wJResp	= JavaObject( 'de.sciss.swingosc.WindowResponder', server, dlg.id );
		dlg.setVisible( true );
	}
	
	*savePanel { arg okFunc,cancelFunc;
		if(result.notNil,{
			"A SwingDialog is already in progress.  do: [SwingDialog.clear]".warn;
			^nil
		});
		result = String.new(512);
		ok = okFunc;
		cancel = cancelFunc;
		this.prSavePanel(result);
	}
	*prSavePanel { arg argResult;
//		_Swing_SavePanel
//		^this.primitiveFailed
		this.prShowDialog( "Save", 1 );
	}
			
	*ok {
		var res;
		res = result;
		cancel = result = nil;
		ok.value(res);
		ok = nil;
	}
	*cancel {
		var res;
		res = result;
		ok = result = nil;
		cancel.value(res);
		cancel = nil;
	}
	*error {
		this.clear;
		"An error has occured during a SwingDialog".error;
	}
	*clear { // in case of errors, invalidate any previous dialogs
		ok = cancel = result = nil;
	}
}

//Swing {
//
//	*getPathsInDirectory { arg directoryPath,extension,maxItems=1000;
//		^this.prGetPathsInDirectory(directoryPath,extension,Array.new(maxItems));
//		//throws an index out of range if more than maxItems items are in the directory
//		
//		//extension matching not yet implemented
//	}
//	*prGetPathsInDirectory { arg dir,ext,arr;
//		_Swing_GetPathsInDirectory;
//		^this.primitiveFailed
//	}
//}
